import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class Assage extends PApplet {

Actor player;
ArrayList objects;
PFont helvetica;
int money = 0;
int soul = 100;
int salary = 100;
int raiseFactor = 3;
int selloutFactor = 20;
int gameState = 0;

public void setup() {
  size (600, 96);
  objects = new ArrayList();
  helvetica = loadFont("Helvetica-48.vlw");
                                        // SIZE                 //POSITION
  player = new Actor("character.png", new PVector(27,49), new PVector(0, 0));
  player.player = true;

                                        // SIZE                 //POSITION
  objects.add(new Actor("chest.png", new PVector (30,30), new PVector(10, 50)));
  objects.add(new Actor("chest.png", new PVector (30,30), new PVector(500, 45)));
  objects.add(new Actor("chest.png", new PVector (30,30), new PVector(100, 10)));
  objects.add(new Actor("chest.png", new PVector (30,30), new PVector(300, 30)));
  objects.add(new Actor("chest.png", new PVector (30,30), new PVector(200, 70)));
}

public void draw() {
  background(66);
  if (gameState == 0) {
    //HUD
    textFont(helvetica, 25);
  //  text("$" + money, 500, 80);
    text("Someday, I will be CEO\nof a big game company...\n(Press any key to play)", 0, 21);

  } else if (gameState == 1) {
    //
    //UPDATE
    if (soul <= 0) {
      gameState = 2;
    }
    player.update();

    for (int i = 0; i < objects.size(); i++) {
      Actor currentObject = (Actor)objects.get(i);
      currentObject.update();

      if (currentObject.collidesWith(player)){
        if (!currentObject.opened) {
          currentObject.opened = true;
          currentObject.switchSprite("chestOpen.png");
          currentObject.setPopupText("Rai$e!");
          salary *= raiseFactor;
          soul -= selloutFactor;
        }
      }
    } 

    //DRAW
    for (int i = 0; i < objects.size(); i++) {
      Actor currentObject = (Actor)objects.get(i);
      currentObject.draw();
    } 
    player.draw();

    //HUD
    textFont(helvetica, 12);
  //  text("$" + money, 500, 80);
    text("Salary $"  + salary, 500, 80);
    text("Soul "  + soul + "%", 500, 95);
  } else if (gameState == 2) {
    //HUD
    textFont(helvetica, 25);
  //  text("$" + money, 500, 80);
    text("Congratulations! You are now CEO\nof MegaGamesCorp International!\nYou are happy.", 0, 20);

    textFont(helvetica, 12);
    text("Salary $"  + salary, 500, 80);
    text("Soul "  + soul + "%", 500, 95);
  }
}

public void keyPressed() {
 if (key == CODED) {
   if (keyCode == UP) {
     player.velocity.y = -1;
   } else if (keyCode == DOWN) {
     player.velocity.y = 1;
   } else if (keyCode == LEFT) {
     player.velocity.x = -1;
   } else if (keyCode == RIGHT) {
     player.velocity.x = 1;
   }
 } else {
   if (key == 'd') {
     println(mouseX + ", " + mouseY);
   }
 }

 if (gameState == 0) {
   gameState = 1;
 }
}

public void keyReleased() {
 if (key == CODED) {
   if (keyCode == UP) {
     player.velocity.y = 0;
   } else if (keyCode == DOWN) {
     player.velocity.y = 0;
   } else if (keyCode == LEFT) {
     player.velocity.x = 0;
   } else if (keyCode == RIGHT) {
     player.velocity.x = 0;
   }
 }
}

class Actor {
  PImage image;
  PVector size;
  PVector position;
  PVector velocity;
  String tag;
  String popupText;
  boolean opened = false;
  boolean player = false;

  Actor(String filename, PVector _size, PVector _position) {
    image = loadImage(filename);
    tag = filename;
    size = _size;
    position = _position;
    velocity = new PVector(0,0);
    popupText = "";
  }

  public void update() {
    position.add(velocity);
  }

  public void draw() {
    pushMatrix();
    translate(position.x, position.y);
    image(image, 0, 0, size.x, size.y);
    textFont(helvetica, 12);
    text(popupText, 0, 0);
    popMatrix();
  }

  public void switchSprite(String filename) {
    image = loadImage(filename);
  }

  public void setPopupText(String text) {
    popupText = text;
  }

  public boolean collidesWith(Actor otherActor){
    boolean collides = false;
    
    float myMinX = position.x;
    float myMaxX = position.x + size.x;
    float myMinY = position.y;
    float myMaxY = position.y + size.y;

    float theirMinX = otherActor.position.x;
    float theirMaxX = otherActor.position.x + otherActor.size.x;
    float theirMinY = otherActor.position.y;
    float theirMaxY = otherActor.position.y + otherActor.size.y;
    
    if(  myMinX > theirMaxX ||
         myMaxX < theirMinX ||
         myMinY > theirMaxY ||
         myMaxY < theirMinY ) {
       collides = false;  
     } else {
       collides = true;
     }

    return collides;
  }
}
  static public void main(String args[]) {
    PApplet.main(new String[] { "--present", "--bgcolor=#666666", "--stop-color=#cccccc", "Assage" });
  }
}
